-- scope stuff
gearquipper = gearquipper or {};
local c = gearquipper;

c.FIELD_CURRENTSET = "FIELD_CURRENTSET";
c.FIELD_SETS = "FIELD_SETS";
c.FIELD_SLOTS = "FIELD_SLOTS";
c.FIELD_ACTIVESLOTS = "FIELD_ACTIVESLOTS";

c.VALUE_NONE = "VALUE_NONE";

function c:LoadSetNames()
	local setNames = {};
	for setName in pairs(GQ_DATA[c.realmName][c.charName][c.FIELD_SETS]) do
		table.insert(setNames, setName);
	end
	return setNames;
end

function c:LoadSet(setName)
	setName = setName or c:GetText("default");
	return GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][setName];
end

function c:SaveDefaultSet()
	c:SaveSet(c:GetText("default"), true);
end

function c:SaveSet(setName, saveAll)
	if setName then
		GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][setName] = GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][setName] or {};
		GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][setName][c.FIELD_SLOTS] = GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][setName][c.FIELD_SLOTS] or {};

		for slotId, slotName in pairs(c.slotInfo) do
			if c:IsSlotActive(slotId) or saveAll then
				local itemId = c:GetItemId(slotId);
				if itemId then
					GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][setName][c.FIELD_SLOTS][slotId] = itemId;
				else
					GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][setName][c.FIELD_SLOTS][slotId] = c.VALUE_NONE;
				end
			end
		end

		c:SaveCurrentSetName(setName);
	end
end

function c:SaveSlot(slotId)
	GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][c:LoadCurrentSetName()][c.FIELD_SLOTS][slotId] = c:GetItemId(slotId);
end

function c:DeleteSet(setName)
	if GQ_DATA[c.realmName][c.charName][c.FIELD_CURRENTSET] == setName then
		c:SaveCurrentSetName(nil);
	end
	GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][setName] = nil;
end

function c:LoadCurrentSetName()
	return GQ_DATA[c.realmName][c.charName][c.FIELD_CURRENTSET];
end

function c:LoadCurrentSet()
	local currentSetName = c:LoadCurrentSetName();
	if currentSetName then
		return GQ_DATA[c.realmName][c.charName][c.FIELD_SETS][currentSetName];
	end
end

function c:SaveCurrentSetName(setName)
	GQ_DATA[c.realmName][c.charName][c.FIELD_CURRENTSET] = setName;
end

function c:SaveSlotActive(slotId, active)
	GQ_DATA[c.realmName][c.charName][c.FIELD_ACTIVESLOTS] = GQ_DATA[c.realmName][c.charName][c.FIELD_ACTIVESLOTS] or {};
	GQ_DATA[c.realmName][c.charName][c.FIELD_ACTIVESLOTS][slotId] = active;
end

function c:LoadSlotActive()
	return GQ_DATA[c.realmName][c.charName][c.FIELD_ACTIVESLOTS];
end