-- scope stuff
gearquipper = gearquipper or {};
local c = gearquipper;

c.SLOT_AMMO = "AmmoSlot";				--  1
c.SLOT_HEAD = "HeadSlot";				--  2
c.SLOT_NECK = "NeckSlot";				--  3
c.SLOT_SHOULDER = "ShoulderSlot";		--  4
c.SLOT_SHIRT = "ShirtSlot";				--  5
c.SLOT_CHEST = "ChestSlot";				--  6
c.SLOT_WAIST = "WaistSlot";				--  7
c.SLOT_LEGS = "LegsSlot";				--  8
c.SLOT_FEET = "FeetSlot";				--  9
c.SLOT_WRIST = "WristSlot";				-- 10
c.SLOT_HANDS = "HandsSlot";				-- 11
c.SLOT_FINGER1 = "Finger0Slot";			-- 12
c.SLOT_FINGER2 = "Finger1Slot";			-- 13
c.SLOT_TRINKET1 = "Trinket0Slot";		-- 14
c.SLOT_TRINKET2 = "Trinket1Slot";		-- 15
c.SLOT_BACK = "BackSlot";				-- 16
c.SLOT_MAINHAND = "MainHandSlot";		-- 17
c.SLOT_OFFHAND = "SecondaryHandSlot";	-- 18
c.SLOT_RANGED = "RangedSlot";			-- 19
c.SLOT_TABARD = "TabardSlot";			-- 20

c.slotInfo = {
	[INVSLOT_AMMO] = c.SLOT_AMMO,
	[INVSLOT_HEAD] = c.SLOT_HEAD,
	[INVSLOT_NECK] = c.SLOT_NECK,
	[INVSLOT_SHOULDER] = c.SLOT_SHOULDER,
	[INVSLOT_BODY] = c.SLOT_SHIRT,
	[INVSLOT_CHEST] = c.SLOT_CHEST,
	[INVSLOT_WAIST] = c.SLOT_WAIST,
	[INVSLOT_LEGS] = c.SLOT_LEGS,
	[INVSLOT_FEET] = c.SLOT_FEET,
	[INVSLOT_WRIST] = c.SLOT_WRIST,
	[INVSLOT_HAND] = c.SLOT_HANDS,
	[INVSLOT_FINGER1] = c.SLOT_FINGER1,
	[INVSLOT_FINGER2] = c.SLOT_FINGER2,
	[INVSLOT_TRINKET1] = c.SLOT_TRINKET1,
	[INVSLOT_TRINKET2] = c.SLOT_TRINKET2,
	[INVSLOT_BACK] = c.SLOT_BACK,
	[INVSLOT_MAINHAND] = c.SLOT_MAINHAND,
	[INVSLOT_OFFHAND] = c.SLOT_OFFHAND,
	[INVSLOT_RANGED] = c.SLOT_RANGED,
	[INVSLOT_TABARD] = c.SLOT_TABARD
};

function c:GetSlotId(slotName)
	for slotId, name in ipairs(c.slotInfo) do
		if name == slotName then
			return slotId;
		end
	end
end

function c:GetItemId(slotId)
	local itemId = GetInventoryItemID("player", slotId);
	if itemId then
		return itemId;
	end
	return c.VALUE_NONE;
end

function c:Println(str)
	if str then
		print("[GearQuipper] " .. str);
	end
end

function c:StartsWith(str, substr)
   return string.sub(str, 1, string.len(substr)) == substr;
end

function c:Trim(str)
	if str then
		return str:gsub("%s+", "");
	end
end

function c:BoolToYesNo(value)
	if value then
		return c:GetText("yes");
	end
	return c:GetText("no");
end

function c:GetTableSize(t)
    local count = 0
    for _, __ in pairs(t) do
        count = count + 1
    end
    return count
end